#!/usr/local/bin/perl
# ----------------------------------------------------------------------------
# FrameIt Setup Script version 5.13 (01/17/2000)
#
# Copyright (c) 1999 Jason M. Hinkle. All rights reserved. This program is
# free software; you may redistribute it and/or modify it under the same
# terms as Perl itself.
# For more information see: http://www.verysimple.com/scripts/
#
# LEGAL DISCLAIMER:
# This software is provided as-is.  Use it at your own risk.  The
# author takes no responsibility for any damages or losses directly
# or indirectly caused by this software.
# ----------------------------------------------------------------------------

$script_version = "5.12";
$setup_script_url = $ENV{'SCRIPT_NAME'};
$default_script_name = "FrameIt.cgi";
$default_logfile_name = "FrameIt.log";
$default_configfile_name = "FrameIt.cfg";

# -----------------------------------------------------------------------
# main routine 1.0
# -----------------------------------------------------------------------

&read_parse;

# set defaults and stuff.  this is pretty clumbsy, but i'm sick of
# writing this damn setup program!
$required_module = "CGI.pm";
$config_file_location = $in{'configFile'} || &get_current_dir() . $default_configfile_name;
$script_location = $in{'scriptFile'} || &get_current_dir() . $default_script_name;
$frameit_url = $in{'frameitUrl'} || &get_current_url() . $default_script_name;
$allowOnlyAuthorized = $in{'allowOnlyAuthorized'} || "1";
$allowOnlyAuthorized = "0" if ($in{'allowOnlyAuthorized'} eq "0");
$restrictUnauthorized = $in{'restrictUnauthorized'} || "1";
$restrictUnauthorized = "0" if ($in{'restrictUnauthorized'} eq "0");
$showUrlWizard = $in{'showUrlWizard'} || "1";
$showUrlWizard = "0" if ($in{'showUrlWizard'} eq "0");
$showDebug = $in{'showDebug'} || "0";
$showWarnings = $in{'showWarnings'} || "0";
$showAd = $in{'showAd'} || "0";
$hideAdAuthorized = $in{'hideAdAuthorized'} || "1";
$hideAdAuthorized = "0" if ($in{'hideAdAuthorized'} eq "0");
$adText = $in{'adText'} || "Powered+By+VerySimple+Scripts";
$adUrl = $in{'adUrl'} || "http://www.verysimple.com/scripts/";
$enableLogging = $in{'enableLogging'} || "0";
$logFilePath = $in{'logFilePath'} || &get_current_dir() . $default_logfile_name;
$text = $in{'text'} || "Back";
$footerSize = $in{'footerSize'} || "35";
$footerBgColor = $in{'footerBgColor'} || "FFFFFF";
$footerBackground = $in{'footerBackground'} || "";
$footerTextColor = $in{'footerTextColor'} || "000000";
$footerFontFace = $in{'footerFontFace'} || "Arial,Helvetica";
$footerFontSize = $in{'footerFontSize'} || "2";
$footerLocation = $in{'footerLocation'} || "1";
$showRemoveFrame = $in{'showRemoveFrame'} || "0";
$link = $in{'link'} || "";
$footerUrl = $in{'footerUrl'} || "";
$bodyFrame = $in{'bodyFrame'} || "body";
$footerFrame = $in{footerFrame} || "footer";
$linkTarget = $in{'linkTarget'} || "_top";
$allowResize = $in{'allowResize'} || "0";
$frameBorder = $in{'frameBorder'} || "1";
$frameBorder = "0" if ($in{'frameBorder'} eq "0");

# -----------------------------------------------------------------------
# VIEW CONFIGFILE
# -----------------------------------------------------------------------
if ($in{'viewConfig'}) {

	unless ($ENV{'HTTP_REFERER'} eq "http://" . $ENV{'HTTP_HOST'} . $ENV{'SCRIPT_NAME'} || $ENV{'HTTP_REFERER'} eq "https://" . $ENV{'HTTP_HOST'} . $ENV{'SCRIPT_NAME'}) {
		$message .= "As a security precaution, only the current config\n";
		$message .= "file may be viewed with this utility.\n";
	} else {
		open(CONFIGFILE, "$in{'configFile'}");
		@config = <CONFIGFILE>;
		close CONFIGFILE;
		foreach $config (@config) {
			$message .= $config;
		}

	}
	&out("", "<pre>" . $message . "</pre>");
}

# -----------------------------------------------------------------------
# STEP 1: DEFAULT SCREEN
# -----------------------------------------------------------------------
unless ($in{'step'}) {
	$message = "<b><font size=\"3\">Welcome to FrameIt $script_version Setup</font></b>\n";
	$message .= "<p>\n";
	$message .= "This program will help you configure FrameIt to run on<br>\n";
	$message .= "your server.  Please choose one of the following setup<br>\n";
	$message .= "options below and click Continue...\n";
	$message .= "<p>\n";
	$message .= "You can run this setup program again at any time.  It is<br>\n";
	$message .= "recommended that you use the standard setup to get <br>\n";
	$message .= "FrameIt working, then run setup again if you want to<br>\n";
	$message .= "make changes or customize the installation. \n";
	$message .= "<p>\n";
	$message .= "<input type=\"radio\" name=\"advancedSetup\" value=\"\" checked> <b>Standard Setup</b> (recommended)<br>\n";
	$message .= "<input type=\"radio\" name=\"advancedSetup\" value=\"1\"> <b>Advanced Setup</b><br>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"2\">\n";
	&out("Continue...", $message);
}

# -----------------------------------------------------------------------
# STEP 2 Advanced:
# -----------------------------------------------------------------------

if ($in{'step'} eq "2" && $in{'advancedSetup'} && !$in{'advanced_1'}) {
	$message = "<b><font size=\"3\">FrameIt 5 Advanced Setup</font></b>\n";
	$message .= "<p>\n";
	$message .= "Specify the config file you want to edit:<br>\n";
	$message .= "<input type=\"text\" name=\"configFile\" value=\"$config_file_location\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Specify the file path to FrameIt.cgi:<br>\n";
	$message .= "<input type=\"text\" name=\"scriptFile\" value=\"$script_location\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Specify the URL to FrameIt.cgi:<br>\n";
	$message .= "<input type=\"text\" name=\"frameitUrl\" value=\"$frameit_url\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"2\">\n";
	$message .= "<input type=\"hidden\" name=\"advanced_1\" value=\"1\">\n";
	&out("Continue...", $message);
}


# -----------------------------------------------------------------------
# STEP 2: FILE CONFIGURATION
# -----------------------------------------------------------------------

if ($in{'step'} eq "2") {
	$message = "<b><font size=\"3\">FrameIt 5 File Configuration</font></b>\n";
	$message .= "<p>\n";
	$message .= "<i>Setup will now test your file configuration...</i>\n";
	$message .= "<p>\n";
	
	$PERL_VERSION = $];
	$scriptExists = (-e "$script_location");
	$scriptIsReadable = (-r "$script_location");
	$scriptIsExecutable = (-x "$script_location") || $ENV{'PATH_TRANSLATED'};
	$scriptIsWritable = (-w "$script_location");
	$configFileExists = (-e "$config_file_location");
	$configFileReadable = (-r "$config_file_location");
	$configFileWritable = (-w "$config_file_location");
	$perlVersionOk = "1" if ($PERL_VERSION eq 5 || $PERL_VERSION > 5);
	push(@INC,`pwd`);
	foreach $includepath (@INC) {
		$testpath = $includepath . "/" . $required_module;
		$requiredModuleInstalled = "1" if (-r "$testpath");
	}
		
	$message .= "$script_location: ";
	$message .= "<font color=\"#008000\">r/x permission ok</font>\n" if ($scriptExists && $scriptIsExecutable);
	$message .= "<font color=\"#ff0000\">not installed </font>" unless ($scriptExists);
	$message .= "<font color=\"#ff0000\">not readable </font>" unless ($scriptIsReadable || !$scriptExists);
	$message .= "<font color=\"#ff0000\">not executable</font>" unless ($scriptIsExecutable || !$scriptExists);
	$message .= "<br>\n";
	$message .= "$config_file_location: ";
	$message .= "<font color=\"#008000\">r/w permission ok</font>" if ($configFileReadable && $configFileWritable);
	$message .= "<font color=\"#ff0000\">not installed </font>" unless ($configFileExists);
	$message .= "<font color=\"#ff0000\">not readable </font>" unless ($configFileReadable || !$configFileExists);
	$message .= "<font color=\"#ff0000\">not writable</font>" unless ($configFileWritable || !$configFileExists);
	$message .= "<br>\n";
	$message .= "Perl version: ";
	$message .= "<font color=\"#008000\">$PERL_VERSION</font><br>\n" if ($perlVersionOk);
	$message .= "<font color=\"#ff0000\">error</font><br>\n" unless ($perlVersionOk);
	$message .= "$required_module module: ";
	$message .= "<font color=\"#008000\">installed</font><br>\n" if ($requiredModuleInstalled);
	$message .= "<font color=\"#ff0000\">not installed</font><br>\n" unless ($requiredModuleInstalled);

	$message .= "<hr><p>\n";

	if (!$perlVersionOk) {
		$message .= "Perl version 5.0 or higher is required to install this script.<br>\n";
		$message .= "The server returned the following Perl version:<br>\n";
		$message .= "$PERL_VERSION<br>\n";
		$message .= "<p>\n";
		$message .= "Please contact your server administrator and have them upgrade<br>\n";
		$message .= "to the most recent version of Perl.  It is also possible that<br>\n";
		$message .= "more than one version of Perl is installed, but you have specified<br>\n";
		$message .= "the path to an old version in line 1 of this setup program.\n";
		$message .= "<p><b>Setup cannot continue.</b>\n";
		$message .= "<p>\n";
		&out("", $message);
	}


	if (!$requiredModuleInstalled) {
		$message .= "To continue with the installation, the Perl module $required_module<br>\n";
		$message .= "is required.  Please install this module.  After you<br>\n";
		$message .= "have done this, click <b>Refresh</b> on your browser to continue.<br>\n";
		$message .= "<p>\n";
		$message .= "<a href=\"http://www.verysimple.com/scripts/support_modules.html\" target=\"support\">Click here for help installing modules...</a>\n";
		$message .= "<p>\n";
		&out("", $message);
	}

	if (!$configFileExists) {
		$message .= "To continue with the installation, the file $config_file_location is needed.<br>\n";
		$message .= "This setup program, the config file and the script should all <br>\n";
		$message .= "be installed in the same directory.  To continue, please copy <br>\n";
		$message .= "$config_file_location to this directory, then click <b>Refresh</b> on your browser.<br>\n";
		$message .= "<p>\n";
		&out("", $message);
	}

	if (!$scriptExists) {
		$message .= "To continue with the installation, the file $script_location is needed.<br>\n";
		$message .= "This setup program, the config file and the script should all <br>\n";
		$message .= "be installed in the same directory.  To continue, please copy <br>\n";
		$message .= "$script_location to this directory, then click <b>Refresh</b> on your browser.<br>\n";
		$message .= "<p>\n";
		&out("", $message);
	}

	if (!$scriptIsReadable || !$scriptIsExecutable) {
		$message .= "To continue with the installation, the script file must be readable<br>\n";
		$message .= "and executable.  For security, file permissions cannot<br>\n";
		$message .= "be changed through this setup program and you will need to do<br>\n";
		$message .= "that manually.  Please change the file permissions on $script_location<br>\n";
		$message .= "so that the web browser can read and execute the file.  After you<br>\n";
		$message .= "have done this, click <b>Refresh</b> on your browser to continue.<br>\n";
		$message .= "<p>\n";
		$message .= "<a href=\"http://www.verysimple.com/scripts/support_filepermissions.html\" target=\"support\">Click here for help with file permissions...</a>\n";
		$message .= "<p>\n";
		&out("", $message);
	}

	if (!$configFileReadable || !$configFileWritable) {
		$message .= "To continue with the installation, setup needs to read and write<br>\n";
		$message .= "to the configuration file.  For security, file permissions cannot<br>\n";
		$message .= "be changed through this setup program and you will need to do<br>\n";
		$message .= "that manually.  Please change the file permissions on $config_file_location<br>\n";
		$message .= "so that the web browser can read and write to the file.  After you<br>\n";
		$message .= "have done this, click <b>Refresh</b> on your browser to continue.<br>\n";
		$message .= "<p>\n";
		$message .= "<a href=\"http://www.verysimple.com/scripts/support_filepermissions.html\" target=\"support\">Click here for help with file permissions...</a>\n";
		$message .= "<p>\n";
		&out("", $message);
	}

	if ($scriptIsWritable) {
		$message .= "<b>Security warning:</b> $script_location is writable.<br>\n";
		$message .= "You may proceed with the installation, however, it is not<br>\n";
		$message .= "necessary that the script file is writable by the web browser.<br>\n";
		$message .= "For security reasons, it is recommended that you change<br>\n";
		$message .= "the file permission before continuing to the next step.<p>\n";
		$message .= "<p>\n";
		$message .= "<a href=\"http://www.verysimple.com/scripts/support_filepermissions.html\" target=\"support\">Click here for help with file permissions...</a>\n";
		$message .= "<p>\n";
	}

	
	if ($configFileReadable && $configFileWritable) {
		$message .= "<b>Click continue to proceed with setup.</b><br>\n";
	}

	$message .= "<input type=\"hidden\" name=\"step\" value=\"3\">\n";
	&out("Continue...", $message);
}

# -----------------------------------------------------------------------
# STEP 3: AUTHORIZED DOMAINS
# -----------------------------------------------------------------------

if ($in{'step'} eq "3") {
	$message = "<b><font size=\"3\">FrameIt 5 Authorized Domains</font></b>\n";
	$message .= "<p>\n";
	$message .= "Next we need to know what domains will have full access<br>\n";
	$message .= "to FrameIt.  Please enter all of the domains below that<br>\n";
	$message .= "will be authorized to use FrameIt.  If you have more than one<br>\n";
	$message .= "domain, separate each with a comma.<p>\n";
	$message .= "<input type=\"text\" name=\"authorizedDomains\" value=\"verysimple.com,simplesubmit.com\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"4\">\n";
	&out("Continue...", $message);
}

# -----------------------------------------------------------------------
# STEP 4 Advanced:
# -----------------------------------------------------------------------

if ($in{'step'} eq "4" && $in{'advancedSetup'} && !$in{'advanced_4'}) {
	$message = "<b><font size=\"3\">FrameIt 5 Advanced Security Setup</font></b>\n";
	$message .= "<p><font color=\"#FF0000\">\n";
	$message .= "Warning: changing the security settings can allow people to<br>\n";
	$message .= "abuse the script and steal your server bandwidth.  Make changes<br>\n";
	$message .= "to this section with caution!\n";
	$message .= "</font><p>\n";
	$message .= "Do you want to allow unauthorized domains to use FrameIt?<br>\n";
	$message .= "<select name=\"allowOnlyAuthorized\"><option value=\"0\">Yes<option value=\"1\" selected>No (default)</select>\n";
	$message .= "<p>\n";
	$message .= "Do you want to limit features available to unauthorized domains?<br>\n";
	$message .= "<select name=\"restrictUnauthorized\"><option value=\"1\">Yes (default)<option value=\"0\">No</select>\n";
	$message .= "<p>\n";
	$message .= "Do you want to show the URL wizard?<br>\n";
	$message .= "<select name=\"showUrlWizard\"><option value=\"1\">Yes (default)<option value=\"0\">No</select>\n";
	$message .= "<p>\n";
	$message .= "Display DebugMode option on the URL wizard?<br>\n";
	$message .= "<select name=\"showDebug\"><option value=\"1\">Yes<option value=\"0\" selected>No (default)</select>\n";
	$message .= "<p>\n";
	$message .= "Do you want to show non-fatal script warnings?<br>\n";
	$message .= "<select name=\"showWarnings\"><option value=\"1\">Yes<option value=\"0\" selected>No (default)</select>\n";
	$message .= "<p>\n";
	$message .= "Ban the following domains from using FrameIt<br>\n";
	$message .= "<input type=\"text\" name=\"bannedDomains\" value=\"hacker.edu,porno.edu\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"4\">\n";
	$message .= "<input type=\"hidden\" name=\"advanced_4\" value=\"1\">\n";
	&out("Continue...", $message);
}

if ($in{'step'} eq "4" && $in{'advancedSetup'} && $in{'advanced_4'} eq "1") {
	$message = "<b><font size=\"3\">FrameIt 5 Advanced Logging Setup</font></b>\n";
	$message .= "<p>\n";
	$message .= "Do you want FrameIt to log access?<br>\n";
	$message .= "<select name=\"enableLogging\"><option value=\"1\">Yes<option value=\"0\" selected>No (default)</select>\n";
	$message .= "<p>\n";
	$message .= "Where is the logfile located:<br>\n";
	$message .= "<input type=\"text\" name=\"logFilePath\" value=\"$logFilePath\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Note: you must make sure that the logfile is writable.  FrameIt<br>\n";
	$message .= "will warn you if it can't write to the logfile only if you selected<br>\n";
	$message .= "'show warnings' on the previous screen.\n";
	$message .= "<p>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"4\">\n";
	$in{'advanced_4'} = "2";
	&out("Continue...", $message);
}

if ($in{'step'} eq "4" && $in{'advancedSetup'} && $in{'advanced_4'} eq "2" & $in{'enableLogging'}) {

	unless (-e $in{'logFilePath'}) {
		$message = "<b><font size=\"3\">FrameIt 5 Advanced Logging Setup</font></b>\n";
		$message .= "<p>\n";
		$message .= "<font color=\"#FF0000\">$in{'logFilePath'} not installed</font><br>\n";
		$message .= "<p>\n";
		$message .= "On the previous screen, you specified that you want<br>\n";
		$message .= "FrameIt to log all activity to the file: ";
		$message .= "$in{'logFilePath'}<p>\n";
		$message .= "This file does not exist on the server.  Please copy<br>\n";
		$message .= "the file to the server and then click <b>Refresh</b>.<br>\n";
		$message .= "<p>\n";
		&out("", $message);
	}
	unless (-w $in{'logFilePath'}) {
		$message = "<b><font size=\"3\">FrameIt 5 Advanced Logging Setup</font></b>\n";
		$message .= "<p>\n";
		$message .= "<font color=\"#FF0000\">$in{'logFilePath'} not writable</font><br>\n";
		$message .= "<p>\n";
		$message .= "On the previous screen, you specified that you want<br>\n";
		$message .= "FrameIt to log all activity to the file: ";
		$message .= "$in{'logFilePath'}<p>\n";
		$message .= "This file needs to be writable by the web browser.<br>\n";
		$message .= "Please change the permissions on the file now so that<br>\n";
		$message .= "the logfile is writable and then click <b>Refresh</b>.<br>\n";
		$message .= "<p>\n";
		$message .= "<a href=\"http://www.verysimple.com/scripts/support_filepermissions.html\" target=\"support\">Click here for help with file permissions...</a><br>\n";
		$message .= "<p>\n";
		&out("", $message);
	}
}

if ($in{'step'} eq "4" && $in{'advancedSetup'} && $in{'advanced_4'} eq "2") {
	$message = "<b><font size=\"3\">FrameIt 5 Advanced Advertising Setup</font></b>\n";
	$message .= "<p>\n";
	$message .= "Do you want FrameIt to display an Ad in the footer?<br>\n";
	$message .= "<select name=\"showAd\"><option value=\"1\">Yes<option value=\"0\" selected>No (default)</select>\n";
	$message .= "<p>\n";
	$message .= "Do you want to show the Ad only for unauthorized domains:<br>\n";
	$message .= "<select name=\"hideAdAuthorized\"><option value=\"1\">Yes (default)<option value=\"0\">No</select>\n";
	$message .= "<p>\n";
	$message .= "What is the Ad text (Use + for spaces):<br>\n";
	$message .= "<input type=\"text\" name=\"adText\" value=\"Powered+By+VerySimple+Scripts\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "What is the Ad URL:<br>\n";
	$message .= "<input type=\"text\" name=\"adUrl\" value=\"http://www.verysimple.com/scripts/\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"4\">\n";
	$in{'advanced_4'} = "3";
	&out("Continue...", $message);
}


# -----------------------------------------------------------------------
# STEP 4: Basic Defaults
# -----------------------------------------------------------------------

if ($in{'step'} eq "4") {
	$message = "<b><font size=\"3\">FrameIt 5 Basic Defaults</font></b>\n";
	$message .= "<p>\n";
	$message .= "There are two default values that sometimes appear when using<br>\n";
	$message .= "FrameIt.  You will probably want to change these to reflect the<br>\n";
	$message .= "name of your site:<p>\n";
	$message .= "Enter the default Browser Title used for FrameIt links:<br>\n";
	$message .= "<input type=\"text\" name=\"title\" value=\"FrameIt Link\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Enter the default URL used for FrameIt links:<br>\n";
	$message .= "<input type=\"text\" name=\"url\" value=\"http://www.verysimple.com/scripts/\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"5\">\n";
	&out("Continue...", $message);
}

# -----------------------------------------------------------------------
# STEP 5 ADVANCED:
# -----------------------------------------------------------------------
if ($in{'step'} eq "5" && $in{'advancedSetup'} && !$in{'advanced_5'}) {
	$message = "<b><font size=\"3\">FrameIt 5 Advanced Defaults</font></b>\n";
	$message .= "<p>\n";
	$message .= "Default text for footer:<br>\n";
	$message .= "<input type=\"text\" name=\"text\" value=\"Back\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Default footer size (in pixels):<br>\n";
	$message .= "<input type=\"text\" name=\"footerSize\" value=\"35\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Default footer background color (Don't use # character):<br>\n";
	$message .= "<input type=\"text\" name=\"footerBgColor\" value=\"ffcc66\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Default footer background image (URL to an image file):<br>\n";
	$message .= "<input type=\"text\" name=\"footerBackground\" value=\"\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Default footer text color (Don't use # character):<br>\n";
	$message .= "<input type=\"text\" name=\"footerTextColor\" value=\"0000ff\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Default footer font face:<br>\n";
	$message .= "<input type=\"text\" name=\"footerFontFace\" value=\"Arial,Helvetica\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Default footer font size:<br>\n";
	$message .= "<input type=\"text\" name=\"footerFontSize\" value=\"2\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Default footer location:<br>\n";
	$message .= "<select name=\"footerLocation\"><option value=\"1\">Bottom (default)<option value=\"2\">Top<option value=\"3\">Redirect (no frames)</select>\n";
	$message .= "<p>\n";
	$message .= "Show 'Remove Frame' link by default:<br>\n";
	$message .= "<select name=\"showRemoveFrame\"><option value=\"1\">Yes<option value=\"0\" selected>No (default)</select>\n";
	$message .= "<p>\n";
	$message .= "<font color=\"#FF0000\">The two options below are normally left blank</font>\n";
	$message .= "<p>\n";
	$message .= "By default, override the referring URL with this URL:<br>\n";
	$message .= "<input type=\"text\" name=\"link\" value=\"\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "By default, use a custom footer (enter URL):<br>\n";
	$message .= "<input type=\"text\" name=\"footerUrl\" value=\"\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"5\">\n";
	$in{'advanced_5'} = "1";
	&out("Continue...", $message);
}


# -----------------------------------------------------------------------
# STEP 5 ADVANCED 2:
# -----------------------------------------------------------------------
if ($in{'step'} eq "5" && $in{'advancedSetup'} && $in{'advanced_5'} eq "1") {
	$message = "<b><font size=\"3\">FrameIt 5 Advanced Frameset Defaults</font></b>\n";
	$message .= "<p>\n";
	$message .= "Frame name for body frame:<br>\n";
	$message .= "<input type=\"text\" name=\"bodyFrame\" value=\"body\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Frame name for footer frame:<br>\n";
	$message .= "<input type=\"text\" name=\"footerFrame\" value=\"footer\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Default frame target for footer link:<br>\n";
	$message .= "<input type=\"text\" name=\"linkTarget\" value=\"_top\" size=\"45\">\n";
	$message .= "<p>\n";
	$message .= "Allow frame resize:<br>\n";
	$message .= "<select name=\"allowResize\"><option value=\"1\">Yes<option value=\"0\" selected>No (default)</select>\n";
	$message .= "<p>\n";
	$message .= "Show Frame Border:<br>\n";
	$message .= "<select name=\"frameBorder\"><option value=\"1\" selected>Yes (default)<option value=\"0\">No</select>\n";
	$message .= "<p>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"5\">\n";
	$in{'advanced_5'} = "2";
	&out("Continue...", $message);
}


# -----------------------------------------------------------------------
# STEP 5: OUTPUT CONFIG FILE
# -----------------------------------------------------------------------
if ($in{'step'} eq "5") {

	open(CONFIGFILE, ">$config_file_location");
	print CONFIGFILE "# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
	print CONFIGFILE "# FrameIt 5 Configuration File\n";
	print CONFIGFILE "# FrameIt Setup version $script_version\n";
	print CONFIGFILE "# It is recommeded that you do not edit this file manually.\n";
	print CONFIGFILE "# Use FrameIt.setup.cgi to edit this file through your browser.\n";
	print CONFIGFILE "# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
	print CONFIGFILE "\n";
	print CONFIGFILE "# Usage and security settings:\n";
	print CONFIGFILE "_AuthorizedDomains = $in{'authorizedDomains'}\n";
	print CONFIGFILE "_BannedDomains = $in{'bannedDomains'}\n";
	print CONFIGFILE "_AllowOnlyAuthorizedDomains = $allowOnlyAuthorized     # 1 or 0\n";
	print CONFIGFILE "_RestrictUnauthorizedDomains = $restrictUnauthorized    # 1 or 0\n";
	print CONFIGFILE "_ShowUrlWizard = $showUrlWizard                  # 1 or 0\n";
	print CONFIGFILE "_ShowDebugOption = $showDebug                # 1 or 0\n";
	print CONFIGFILE "_ShowWarnings = $showWarnings                   # 1 or 0\n";
	print CONFIGFILE "\n";
	print CONFIGFILE "# Logging options:\n";
	print CONFIGFILE "EnableLogging = $enableLogging                   # 1 or 0\n";
	print CONFIGFILE "LogFilePath = $logFilePath\n";
	print CONFIGFILE "\n";
	print CONFIGFILE "# Default frameset options:\n";
	print CONFIGFILE "FooterFrame = $footerFrame\n";
	print CONFIGFILE "BodyFrame = $bodyFrame\n";
	print CONFIGFILE "LinkTarget = $linkTarget\n";
	print CONFIGFILE "AllowResize = $allowResize                     # 1 or 0\n";
	print CONFIGFILE "FrameBorder = $frameBorder                     # 1 or 0\n";
	print CONFIGFILE "\n";
	print CONFIGFILE "# Default Advertising Settings:\n";
	print CONFIGFILE "ShowAd = $showAd                          # 1 or 0\n";
	print CONFIGFILE "HideAdAuthorized = $hideAdAuthorized                # 1 or 0\n";
	print CONFIGFILE "AdText = $adText\n";
	print CONFIGFILE "AdUrl = $adUrl\n";
	print CONFIGFILE "\n";
	print CONFIGFILE "# Default output settings:\n";
	print CONFIGFILE "Title = $in{'title'}\n";
	print CONFIGFILE "Url = $in{'url'}\n";
	print CONFIGFILE "Text = $text\n";
	print CONFIGFILE "Link = $link\n";
	print CONFIGFILE "FooterSize = $footerSize\n";
	print CONFIGFILE "FooterBgcolor = $footerBgColor       # Don't put a # in front of RGB colors!\n";
	print CONFIGFILE "FooterBackground = $footerBackground\n";
	print CONFIGFILE "FooterTextColor = $footerTextColor     # Don't put a # in front of RGB colors!\n";
	print CONFIGFILE "FooterFontFace = $footerFontFace\n";
	print CONFIGFILE "FooterFontSize = $footerFontSize\n";
	print CONFIGFILE "FooterLocation = $footerLocation                  # 1, 2 or 3\n";
	print CONFIGFILE "ShowRemoveFrame = $showRemoveFrame\n";
	print CONFIGFILE "FooterUrl = $footerUrl\n";
	print CONFIGFILE "\n";
	print CONFIGFILE "# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
    close CONFIGFILE;

	$message = "<b><font size=\"3\">FrameIt 5 Setup Complete</font></b>\n";
	$message .= "<p>\n";
	$message .= "<b>Configuration information was saved to $config_file_location.</b><p>\n";
	$message .= "<p>\n";
	$message .= "It is <b>highly</b> recommended that you now change the file permissions on<br>\n";
	$message .= "$config_file_location so that it is readable, but not writable by the web browser.<br>\n";
	$message .= "If you do not do this, it will be possible for other people to change<br>\n";
	$message .= "your FrameIt configuration settings and/or disable FrameIt altogether.<br>\n";
	$message .= "<p>\n";
	$message .= "For additional security, it is recommended that you change the permission<br>\n";
	$message .= "of this setup file so that it is <b>not</b> executable by the web browser.<br>\n";
	$message .= "<p>\n";
	$message .= "<a href=\"http://www.verysimple.com/scripts/support_filepermissions.html\" target=\"support\">Click here for help with file permissions...</a><br>\n";
	$message .= "<a href=\"FrameItSetup.cgi\">Click here to restart the setup program.</a><br>\n";
	$message .= "<a href=\"$setup_script_url?viewConfig=1&configFile=$config_file_location\">Click here to view the config file</a><p>\n";
	$message .= "<b><a href=\"$frameit_url\">Click here to start using FrameIt</a></b><p>\n";
	$message .= "<input type=\"hidden\" name=\"step\" value=\"6\">\n";

	&out("", $message);
}


	
# -----------------------------------------------------------------------
# subroutine: out (to browser) 1.0
# -----------------------------------------------------------------------
sub out {
    local($button_caption, $message) = @_;

	print "Content-type: text/html\n\n";
	print "<head>\n";
	print "<title>FrameIt Setup</title>\n";
	print "</head>\n";
	print "<body bgcolor=\"#0000cc\" link=\"#0000ff\" vlink=\"#0000ff\">\n";
	print "<i><font size=\"6\" color=\"#FFFFFF\">FrameIt Setup</font></i>\n";
    print "<p>\n";
    print "<form action=\"$setup_script_url\" method=\"post\">\n";
    print "<div align=\"center\">\n";
    print "<table cellspacing=0 cellpadding=5 border=2 bgcolor=\"#cccccc\"><tr><td>\n";
	print "<font face=\"Arial, Helvetica\" size=\"2\">$message</font>\n";
	print "<p align=right><input type=\"Submit\" value=\" $button_caption \">\n" if ($button_caption);
    print "</td></tr></table>\n";
    print "</div>\n";

	&pass_through;
	
	print "</form>\n";
	print "</body>\n";
	print "</html>\n";
	
	exit;
}

# -----------------------------------------------------------------------
# pass_through: version 1.0
# -----------------------------------------------------------------------
sub pass_through {
    foreach $key (keys(%in)) {
		unless ($key eq "step") {
			print "<input type=\"hidden\" name = \"$key\" value=\"$in{$key}\">\n" if ($in{$key} || $in{$key} eq "0");
		}
	}
}

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub get_current_dir {
# version compatible with Perl 4
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	if ($ENV{'PATH_TRANSLATED'}) {
		$pathToScript = $ENV{'PATH_TRANSLATED'};
		$position = rindex ($pathToScript,'\\');
	} else {
		$pathToScript = $ENV{'SCRIPT_FILENAME'}; 
		$position = rindex ($pathToScript,'/');
	}
	$currentDir = substr ($pathToScript,0,$position + 1);
	return $currentDir;
}

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub get_current_url {
# version compatible with Perl 4
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	$pathToScript = $ENV{'SCRIPT_NAME'}; 
	$position = rindex ($pathToScript,'/');
	$currentDir = substr ($pathToScript,0,$position + 1);
	return $currentDir;
}

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub get_filename {
# version compatible with Perl 4
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$gf_filepath = shift;

	if ($ENV{'PATH_TRANSLATED'}) {
		$gf_position = rindex ($gf_filepath,'\\');
	} else {
		$gf_position = rindex ($gf_filepath,'/');
	}
	$gf_filename = substr ($gf_filepath,$gf_position + 1);
	return $gf_filename;
}


# ---------------------------------------------------------------------------
# read_parse v1.1
# Copyright (c) 1998 Jason M. Hinkle
# http://www.verysimple.com/scripts/
# Based on ReadParse v1.14, Copyright (c) 1995 Steven E. Brenner
# Reads in GET, POST or UNIX command line data
# 
# See configuration variable (below) to accept command line input.
# ---------------------------------------------------------------------------
sub read_parse {
  # check if an alternate name is use and localize variables
  local (*in) = @_ if @_;
  local ($i, $key, $val, $accept_command);

  # Global variables returned: $in{field_name}, $method

  # -----------------------------------------------------------------------
  # CONFIGURATION VARIABLE FOR READ_PARSE:
  # -----------------------------------------------------------------------
  # $accept_command = 1 (to accept command line input) or
  # $accept_command = 0 (to block command line input)
  $accept_command = 0;

  # set some global variables
  $method = $ENV{'REQUEST_METHOD'};
  $length  = $ENV{'CONTENT_LENGTH'};

  # determine the request method and read in the text
  
  # check to see if command line data was entered
  if (!defined $method || $method eq '') {
    if ($accept_command) {
        push(@in, @ARGV);
        $method = "COMMAND";  # also use command-line options
    } else {
        die("ERROR: Command line input not accepted\n")
    }
  
  # check to see if data was submitted via GET
  } elsif($method eq 'GET' || $method eq 'HEAD') {
    $in = $ENV{'QUERY_STRING'};
    @in = split(/[&;]/,$in);
  
  # check to see if data was submitted via POST
  } elsif ($method eq 'POST') {
    if (($got = read(STDIN, $in, $length) != $length)) {
      $errflag="Short Read: wanted $length, got $got\n"
    };
    @in = split(/[&;]/,$in);
  
  # otherwise, what the...?
  } else {
    $errflag="Unknown request method: $method\n";
  }

  # Change all the funky characters back to english and assign the variables
  foreach $i (0 .. $#in) {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;

    # Associate key and value
    $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;

  }

  # return the variables using the array name given, or @in
  return scalar(@in);
}